
plugins {
	kotlin("jvm") version "1.8.0"
	`maven-publish`
}

repositories {
	mavenCentral()
}

tasks.compileKotlin {
	kotlinOptions {
		jvmTarget = "17"
		freeCompilerArgs += "-opt-in=kotlin.RequiresOptIn"
		freeCompilerArgs += "-Xjvm-default=all"
	}
}

tasks.jar {
	from(project(":core").sourceSets.main.get().output)
	from(project(":io").sourceSets.main.get().output)
	from(project(":io-math").sourceSets.main.get().output)
	from(project(":math").sourceSets.main.get().output)
	from(project(":collect").sourceSets.main.get().output)
	from(project(":guava").sourceSets.main.get().output)
	from(project(":networking").sourceSets.main.get().output)
}

subprojects {
	apply(plugin = "maven-publish")

	publishing {
		repositories {
			maven {
				url = uri("sftp://maven@dbotthepony.ru:22/maven")

				credentials {
					val mavenUser: String by project
					val mavenPassword: String by project
					username = mavenUser
					password = mavenPassword
				}
			}
		}
	}
}
